var _excluded = ["name", "children", "props"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { usePrefixCls, cls, isStr, isPlainObj, isArr } from '@teamix/utils';
import pureGenProColumnToColumn from '../../table/utils/pureGenProColumnToColumn';
/**
 * 将可被 ProForm 识别的上下文转换为仅被 ProTable 识别的上下文
 * @param value
 * @returns
 */
var adapterContext = function adapterContext(value) {
  if (isStr(value)) {
    var contextReg = /^\{\{.*?\}\}$/;
    if (contextReg.test(value)) {
      return "\0".concat(value, "\0");
    }
    return value;
  }
  if (isPlainObj(value)) {
    var temp = {};
    Object.entries(value).forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        val = _ref2[1];
      temp[key] = adapterContext(val);
    });
    return temp;
  }
  if (isArr(value)) {
    return value.map(function (item) {
      return adapterContext(item);
    });
  }
  return value;
};
var initializeTableColumn = function initializeTableColumn(item) {
  var name = item.name,
    children = item.children,
    props = item.props,
    otherProps = _objectWithoutProperties(item, _excluded);
  return {
    name: name,
    component: 'SelectTable.Column',
    children: children === null || children === void 0 ? void 0 : children.map(function (item) {
      return initializeTableColumn(item);
    }),
    props: _objectSpread(_objectSpread({}, otherProps), props)
  };
};
var initialize = function initialize(item) {
  var _props$columns;
  var _item$children = item.children,
    children = _item$children === void 0 ? [] : _item$children,
    props = item.props;
  var prefixCls = usePrefixCls('teamix-pro-form-select-table-column-tree');
  var columns = props === null || props === void 0 ? void 0 : (_props$columns = props.columns) === null || _props$columns === void 0 ? void 0 : _props$columns.map(function (value, index) {
    var column = adapterContext(value);
    if ((props === null || props === void 0 ? void 0 : props.isTree) && index === 0) {
      return _objectSpread(_objectSpread({}, column), {}, {
        className: cls(prefixCls(), column.className)
      });
    }
    return column;
  });
  return _objectSpread(_objectSpread({}, item), {}, {
    props: _objectSpread(_objectSpread({}, props), {}, {
      columns: columns && pureGenProColumnToColumn(columns)
    }),
    children: children.map(function (item) {
      return initializeTableColumn(item);
    })
  });
};
export default initialize;